<template>
  <div class="main-menu menu-fixed menu-accordion menu-shadow" :class="[
    {
      expanded: !isVerticalMenuCollapsed || (isVerticalMenuCollapsed && isMouseHovered),
    },
    skin === 'light' || skin === 'bordered' ? 'menu-light' : 'menu-dark',
  ]" @mouseenter="updateMouseHovered(true)" @mouseleave="updateMouseHovered(false)">
    <!-- main menu header-->
    <div class="navbar-header expanded">
      <slot name="header" :toggleVerticalMenuActive="toggleVerticalMenuActive" :toggleCollapsed="toggleCollapsed"
        :collapseTogglerIcon="collapseTogglerIcon">
        <ul class="nav navbar-nav flex-row">
          <!-- Logo & Text -->
          <li class="nav-item mr-auto sidebar-header-logo">
            <b-link class="navbar-brand mt-0" to="/" v-if="userData && !userData.company">
              <div v-if="!(
      !isVerticalMenuCollapsed ||
      (isVerticalMenuCollapsed && isMouseHovered)
    )
    ">
                <h2 class="brand-logo">
                  <b-img class="brand-logo-img" :src="appMonoLogoImage" alt="mono-logo" />
                </h2>
              </div>
              <div v-if="!isVerticalMenuCollapsed || (isVerticalMenuCollapsed && isMouseHovered)
    ">
                <h2 class="brand-text ml-1 mt-05">
                  <b-img class="sidebard-brand-logo" :src="appNameImage" alt="logo 00" />
                </h2>
              </div>
            </b-link>

            <b-link class="navbar-brand mt-0" to="/" v-if="userData && userData.company">
              <div v-if="!(
      !isVerticalMenuCollapsed ||
      (isVerticalMenuCollapsed && isMouseHovered)
    )
    ">
                <span class="brand-logo" v-if="companyMono">
                  <b-img :src="companyMono" alt="mono-logo" class="brand-logo-img" />
                </span>
                <span class="brand-logo" v-if="!companyMono">
                  <b-img :src="appMonoLogoImage" class="brand-logo-img" alt="mono-logo" />
                </span>
              </div>
              <div v-if="!isVerticalMenuCollapsed || (isVerticalMenuCollapsed && isMouseHovered)
    ">
                <h5 class="brand-text ml-1 mt-05" v-if="companyLogo">
                  <b-img class="sidebard-brand-logo" :src="companyLogo" alt="logo 0" />
                </h5>
                <h5 class="brand-text ml-1 mt-05" v-if="!companyLogo">
                  <b-img class="sidebard-brand-logo" :src="appNameImage" alt="logo 1" />
                </h5>
              </div>
            </b-link>
          </li>
          <!-- Toggler Button -->
          <li class="nav-item nav-toggle" @click="toggleCollapsed" >
            <b-link class="nav-link modern-nav-toggle mt-1">
              <FeatherIcon icon="XIcon" size="20" class="d-block d-xl-none" @click="toggleVerticalMenuActive" />
              <FeatherIcon v-if="isVerticalMenuCollapsed" :icon="collapseTogglerIconFeather" size="20" class="d-none d-xl-block collapse-toggle-icon"
                @click="toggleCollapsed" />
                <FeatherIcon v-if="!isVerticalMenuCollapsed" :icon="collapseTogglerIconFeather" size="20" class="d-none d-xl-block collapse-toggle-icon"
                @click="toggleCollapsed" />
            </b-link>
          </li>
        </ul>
      </slot>
    </div>
    <!-- / main menu header-->

    <!-- Shadow -->
    <div :class="{ 'd-block': shallShadowBottom }" class="shadow-bottom" />

    <!-- main menu content-->
    <VuePerfectScrollbar :settings="perfectScrollbarSettings" class="main-menu-content scroll-area" tagname="ul"
      @ps-scroll-y="(evt) => {
      shallShadowBottom = evt.srcElement.scrollTop > 0;
    }
    ">
      <vertical-nav-menu-items :items="navMenuItems" class="navigation navigation-main" />
    </VuePerfectScrollbar>
  </div>
</template>

<script>
import VuePerfectScrollbar from "vue-perfect-scrollbar";
import { BLink, BImg } from "bootstrap-vue";
import { provide, computed, ref } from "vue";
import useAppConfig from "@core/app-config/useAppConfig";
import { $themeConfig } from "@themeConfig";
import VerticalNavMenuItems from "./components/vertical-nav-menu-items/VerticalNavMenuItems.vue";
import useVerticalNavMenu from "./useVerticalNavMenu";
import store from "@/store";

export default {
  components: {
    VuePerfectScrollbar,
    VerticalNavMenuItems,
    BLink,
    BImg
  },
  props: {
    isVerticalMenuActive: {
      type: Boolean,
      required: true,
    },
    toggleVerticalMenuActive: {
      type: Function,
      required: true,
    },
    navMenuItems: {
      type: Array,
      required: true,
    },
  },
  setup(props) {
    var { companyLogo, companyMono } = useAppConfig();

    const userData = JSON.parse(localStorage.getItem("userData"));

    if (userData && userData.company) {
      store.commit("appConfig/UPDATE_COMPNAY_MONO", {
        mono: userData.company.mono_logo ? import.meta.env.VITE_API_URL + userData.company.mono_logo : '',
      });

      store.commit("appConfig/UPDATE_COMPNAY_LOGO", {
        logo: userData.company.logo ? import.meta.env.VITE_API_URL + userData.company.logo : '',
      });

      store.commit("appConfig/UPDATE_USER_PROFILE_PHOTO", {
        profilePhoto: userData.profile ? import.meta.env.VITE_API_URL + userData.profile : '',
      });
    }

    const {
      isMouseHovered,
      isVerticalMenuCollapsed,
      collapseTogglerIcon,
      toggleCollapsed,
      updateMouseHovered,
    } = useVerticalNavMenu(props);

    const { skin } = useAppConfig();

    // Shadow bottom is UI specific and can be removed by user => It's not in `useVerticalNavMenu`
    const shallShadowBottom = ref(false);

    provide("isMouseHovered", isMouseHovered);

    const perfectScrollbarSettings = {
      maxScrollbarLength: 60,
      wheelPropagation: false,
    };

    const collapseTogglerIconFeather = computed(() =>
      collapseTogglerIcon.value === "unpinned" ? "CircleIcon" : "DiscIcon"
    );

    // App Name
    const { appName, appMonoLogoImage, appNameImage } = $themeConfig.app;
    return {
      perfectScrollbarSettings,
      isVerticalMenuCollapsed,
      collapseTogglerIcon,
      toggleCollapsed,
      isMouseHovered,
      updateMouseHovered,
      collapseTogglerIconFeather,

      // Shadow Bottom
      shallShadowBottom,

      // Skin
      skin,

      // App Name
      appName,
      appMonoLogoImage,
      appNameImage,
      companyLogo,
      companyMono,
    };
  },
  data() {
    return {
      userData: JSON.parse(localStorage.getItem("userData")),
    };
  },
};
</script>

<style lang="scss">
@import "~@resources/scss/base/core/menu/menu-types/vertical-menu.scss";
// @import "../../../../../scss/base/core/menu/menu-types/vertical-menu.scss";
</style>
